/*
 * mx_osdef.h --- Header file for operating system dependent definitions.
 *
 *--------------------------------------------------------------------------
 *
 * Copyright 1999-2000 Illinois Institute of Technology
 *
 * See the file "LICENSE" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#ifndef _MX_OSDEF_H_
#define _MX_OSDEF_H_

#if defined(OS_LINUX) || defined(OS_AIX) || defined(OS_SOLARIS2) \
 || defined(OS_SUNOS4) || defined(OS_SGI) || defined(OS_HPUX) \
 || defined(OS_MACOSX)

#define OS_UNIX
#endif

#if defined(OS_DOS_EXT_WATCOM) || defined(OS_DJGPP)

#define OS_MSDOS
#endif

/* ==== Operating system dependent parameters. ==== */

#ifdef OS_MSDOS
#  define USE_GETOPT			1

#  ifdef OS_DOS_EXT_WATCOM
#    define USE_FD_SET			0
#    define USE_TCPIP			0
#  elif OS_DJGPP
#    define USE_FD_SET			1
#    define USE_TCPIP			1
#  else
#    define USE_FD_SET			0
#    define USE_TCPIP			0
#  endif

#endif /* OS_MSDOS */

#ifdef OS_WIN32
#  define USE_FD_SET			1
#  define USE_GETOPT			1
#  define USE_TCPIP			1

#endif /* OS_WIN32 */

#ifdef OS_UNIX
#  define USE_FD_SET			1
#  define USE_GETOPT			1
#  define USE_TCPIP			1

#endif /* OS_UNIX */

#ifdef OS_VMS
#  define USE_FD_SET			1
#  define USE_GETOPT			1
#  define USE_TCPIP			1

#endif /* OS_VMS */

#ifdef OS_MPW
#  define USE_FD_SET			1
#  define USE_GETOPT			1
#  define USE_TCPIP			0

#endif /* OS_MPW */

#endif /* _MX_OSDEF_H_ */

