/*
 * Name:    mxunistd.h
 *
 * Purpose: Not every platform has <unistd.h>, so we use this header file
 *          instead of including <unistd.h> directly.
 *
 * Author:  William Lavender
 *
 *------------------------------------------------------------------------
 *
 * Copyright 2000 Illinois Institute of Technology
 *
 * See the file "LICENSE" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#ifndef _MXUNISTD_H_
#define _MXUNISTD_H_

#if defined(OS_WIN32)

#include <io.h>

unsigned int sleep( unsigned int seconds );

#define R_OK  4
#define W_OK  2
#define X_OK  1
#define F_OK  0

#elif defined(OS_MPW)

unsigned int sleep( unsigned int seconds );

#define access  mx_mpw_access

int mx_mpw_access( const char *pathname, int mode );

#define R_OK  4
#define W_OK  2
#define X_OK  1
#define F_OK  0

#else
#include <unistd.h>
#endif

#endif /* _MXUNISTD_H_ */
