/*
 * Name:    ms_mxsrv.h
 *
 * Purpose: Header file for server side of MX network protocol.
 *
 *--------------------------------------------------------------------------
 *
 * Copyright 1999 Illinois Institute of Technology
 *
 * See the file "LICENSE" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#ifndef __MS_MXSRV_H__
#define __MS_MXSRV_H__

typedef struct {
	long field_type;
	mx_status_type (*process_function) (void *, void *, int);
} MX_PROCESS_FUNCTION_LIST_ENTRY;

typedef struct {
	int port;
	MXSRV_EVENT_HANDLER *client_event_handler;
} MXSRV_MX_SERVER_SOCKET;

extern MXSRV_MX_SERVER_SOCKET mxsrv_mx_server_socket_struct;

extern mx_uint32_type mxsrv_get_returning_message_type(
					mx_uint32_type message_type );

extern mx_status_type mxsrv_free_client_socket_handler(
			MXSRV_SOCKET_HANDLER *socket_handler,
			MXSRV_SOCKET_HANDLER_LIST *socket_handler_list );

extern mx_status_type mxsrv_mx_server_socket_init(
			MX_RECORD *record_list,
			MXSRV_SOCKET_HANDLER_LIST *socket_handler_list,
			MXSRV_EVENT_HANDLER *event_handler );

extern mx_status_type mxsrv_mx_server_socket_process_event(
			MX_RECORD *record_list,
			MXSRV_SOCKET_HANDLER *socket_handler,
			MXSRV_SOCKET_HANDLER_LIST *socket_handler_list,
			MXSRV_EVENT_HANDLER *event_handler );

extern mx_status_type mxsrv_mx_client_socket_init(
			MX_RECORD *record_list,
			MXSRV_SOCKET_HANDLER_LIST *socket_handler_list,
			MXSRV_EVENT_HANDLER *event_handler );

extern mx_status_type mxsrv_mx_client_socket_process_event(
			MX_RECORD *record_list,
			MXSRV_SOCKET_HANDLER *socket_handler,
			MXSRV_SOCKET_HANDLER_LIST *socket_handler_list,
			MXSRV_EVENT_HANDLER *event_handler );

extern mx_status_type mxsrv_mx_client_socket_proc_queued_event(
			MXSRV_QUEUED_EVENT *queued_event );

extern mx_status_type mxsrv_handle_get_array_ascii(
			MX_SOCKET mx_socket,
			MX_RECORD *record,
			MX_RECORD_FIELD *record_field,
			void *received_message );

extern mx_status_type mxsrv_handle_put_array_ascii(
			MX_SOCKET mx_socket,
			MX_RECORD *record,
			MX_RECORD_FIELD *record_field,
			void *received_message );

extern mx_status_type mxsrv_handle_get_field_type(
			MX_SOCKET mx_socket,
			MX_RECORD_FIELD *record_field,
			void *message,
			mx_uint32_type message_length );

#endif /* __MS_MXSRV_H__ */
